//-------------------------------------------------------------------------------------
//          Copyright ? 2005-2006 META                                             
//                All Rights Reserved.                                                 
//   The file is generated by Component Wizard for QUALCOMM Mobile Platform            
// FileName:   CMetaDBRecord.c                                                                      
// Author:    nick                          
// Date:       2006-02-22 
//Function: implement IMetaDBRecord interface
// Log:   Author             Date             Description                              
// ------------------------------------------------------------------------------------
//       nick        2009-02-06       Initiate version                                
//-------------------------------------------------------------------------------------
#include "AEEShell.h"
#include "AEEStdLib.h"
#include "AEEBase.h"
#include "IMetaDB.h"
#include "MetaClassID.h"
#include "MetaMemory.h"
#include "AEE_OEMDispatch.h"
#include "AEE_OEM.h"
#include "MetaCommonMacro.h"
#include "MetaTrace.h"
#include "IAList.h"
#include "IMetaDBRecord.h"
#ifndef AEE_SIMULATOR
#if 0
#include "hs_mb6250.h"
#else
#include "hs_mb6100.h"//platform qsc60x0
#endif
#endif

//////////////////////////////////////////////////////////////////////////

#define Max_Meta_Table_Length 20

typedef struct CMetaDBRecord
{
	uint32 nRefs;
	IShell *pIShell;
	IMetaDBRecord myIMetaDBRecord;	
	int nColumn;
	IAList* piColumnList;	
	
}CMetaDBRecord;

// pCMetaDBRecord must be created statically like singleton

/*
typedef struct
{
	MetaDBCallBack pMetaDBCallBack;
	void* pUserData;
	IMetaDB *pIMetaDB;	

}MetaDBCallBackUserData, *PMetaDBCallBackUserData;
*/
/*
int mySQLExecCallBack(void* pUserData, int nCols, char** ppColValues, char** ppColNames)
{
	PMetaDBCallBackUserData pMetaUserData = (PMetaDBCallBackUserData) pUserData;	
}
*/


//static CMetaDBRecord* pCMetaDBRecord = NULL;
/*===========================================================================

                    DEFINITIONS AND CONSTANTS

===========================================================================*/

static uint32 CMetaDBRecord_IBase_AddRef(IMetaDBRecord* pIMetaDBRecord);

static uint32 CMetaDBRecord_IBase_Release(IMetaDBRecord* pIMetaDBRecord);

static int CMetaDBRecord_IBase_QueryInterface(IMetaDBRecord* pIMetaDBRecord, AEECLSID ClsID, void** ppInterface);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// user must guarantee the field id is valid
static int CMetaDBRecord_IMetaDBRecord_InsertField(IMetaDBRecord* pIMetaDBRecord, TMetaDBRecordData* pRecordData);

static int CMetaDBRecord_IMetaDBRecord_RemoveFieldById(IMetaDBRecord* pIMetaDBRecord, int nFieldId);

static int CMetaDBRecord_IMetaDBRecord_RemoveFieldByIndex(IMetaDBRecord* pIMetaDBRecord, ushort nIndex);

static int CMetaDBRecord_IMetaDBRecord_GetFieldCount(IMetaDBRecord* pIMetaDBRecord, ushort* pFieldCount);

static int CMetaDBRecord_IMetaDBRecord_GetFieldPointerById(IMetaDBRecord* pIMetaDBRecord, int nFieldId, TMetaDBRecordData** ppRecordData);

static int CMetaDBRecord_IMetaDBRecord_GetFieldPointerByIndex(IMetaDBRecord* pIMetaDBRecord, ushort nIndex, TMetaDBRecordData** ppRecordData);

static int CMetaDBRecord_IMetaDBRecord_RemoveAll(IMetaDBRecord* pIMetaDBRecord);

static int CMetaDBRecord_IMetaDBRecord_InsertFieldData(IMetaDBRecord* pIMetaDBRecord, int nFieldId, TMetaFieldTypeEnum dataType, void* pRawData, int nDataSize);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
static CMetaDBRecord* CMetaDBRecord_Constructor(IShell* pIShell);

static void CMetaDBRecord_Destructor(CMetaDBRecord* pCMetaDBRecord);


/*

#define IAList_AddRef(pThis)                             pThis->pvt->AddRef(pThis)
#define IAList_Release(pThis)                            pThis->pvt->Release(pThis)
#define IAList_QueryInterface(pThis,ClsID,ppInterface)   pThis->pvt->QueryInterface(pThis,ClsID,ppInterface)
#define IAList_Add(pThis,pElement)                       pThis->pvt->Add(pThis,pElement)
#define IAList_Get(pThis,Position,ppElement)             pThis->pvt->Get(pThis,Position,ppElement)
#define IAList_Insert(pThis,pElement,pPosition)          pThis->pvt->Insert(pThis,pElement,pPosition)
#define IAList_Remove(pThis,Position)                    pThis->pvt->Remove(pThis,Position)
#define IAList_RemoveAll(pThis)                          pThis->pvt->RemoveAll(pThis)
#define IAList_Delete(pThis,Position)                    pThis->pvt->Delete(pThis,Position)
#define IAList_DeleteAll(pThis)                          pThis->pvt->DeleteAll(pThis)
#define IAList_Replace(pThis,pElement,Position,ppPreviousElement)    pThis->pvt->Replace(pThis,pElement,Position,ppPreviousElement)
#define IAList_Sort(pThis)                               pThis->pvt->Sort(pThis)
#define IAlist_Sort_Asyn(pThis,pICBAListSortFinish)		 pThis->pvt->Sort_Asyn(pThis, pICBAListSortFinish)
#define IAList_GetSize(pThis,pSize)                      pThis->pvt->GetSize(pThis,pSize)
#define IAList_RegisterNotify(pThis,CallBackType,pCmpFn,pFreeFn)      pThis->pvt->RegisterNotify(pThis,CallBackType,pCmpFn,pFreeFn)
*/


static const struct AEEVTBL(IMetaDBRecord) gIMetaDBRecordFuncs = 
{
    CMetaDBRecord_IBase_AddRef,

    CMetaDBRecord_IBase_Release,

    CMetaDBRecord_IBase_QueryInterface,
    
	CMetaDBRecord_IMetaDBRecord_GetFieldCount,

	CMetaDBRecord_IMetaDBRecord_InsertField,

	CMetaDBRecord_IMetaDBRecord_RemoveFieldById,

	CMetaDBRecord_IMetaDBRecord_RemoveFieldByIndex,

    CMetaDBRecord_IMetaDBRecord_GetFieldPointerById,

    CMetaDBRecord_IMetaDBRecord_GetFieldPointerByIndex,

	CMetaDBRecord_IMetaDBRecord_InsertFieldData,

	CMetaDBRecord_IMetaDBRecord_RemoveAll,

	
};

//////////////////////////////////////////////////////////////////////////
// utility methods

void MetaDBRecordData_Release(TMetaDBRecordData* pRecord)
{
	switch (pRecord->fieldDesc.type)
	{
	case META_FIELD_BINARY:
	case META_FIELD_TEXT:
	case META_FIELD_WTEXT:		
		break;
	}
	pRecord->len = 0;
}


static int TMetaDBRecordData_Clone(TMetaDBRecordData* pSrc, TMetaDBRecordData** ppDst)
{
	int result = EFAILED;
	int recordSize;
	recordSize = CALC_META_DBRECORD_SIZE(pSrc);

	if ((*ppDst = MetaAlloc(recordSize)) != NULL)
	{
		MEMCPY(*ppDst, pSrc, recordSize);
		result = SUCCESS;		
	}
	return result;
}


/*
static int MetaDBRecordData_CopyFieldData(TMetaDBRecordData** ppDst, int nFieldId, TMetaFieldTypeEnum dataType, void* pRawData, int nDataSize)
{
	int srcRecordSize, dstRecordSize;
	srcRecordSize = META_DBRECORD_SIZE + MAX(nDataSize, sizeof(int32));
	dstRecordSize = CALC_META_DBRECORD_SIZE(*ppDst);;

	if (dstRecordSize < srcRecordSize)
	{
		MetaFree(ppDst);
		if ((*ppDst = MetaAlloc(srcRecordSize)) == NULL)
		{
			return EFAILED;
		}
	}
	(*ppDst)->fieldDesc.type = dataType;
	(*ppDst)->fieldDesc.fieldId = nFieldId;
	(*ppDst)->len = nDataSize;
	memcpy((*ppDst)->pData, pRawData, nDataSize);
	return SUCCESS;
}
*/

static int TMetaDBRecordData_Copy(TMetaDBRecordData* pSrc, TMetaDBRecordData** ppDst)
{
	int result = EFAILED;
	int srcRecordSize, dstRecordSize;
	srcRecordSize = CALC_META_DBRECORD_SIZE(pSrc);
	dstRecordSize = CALC_META_DBRECORD_SIZE((*ppDst));

	if (dstRecordSize >= srcRecordSize)
	{
		MEMCPY(*ppDst, pSrc, srcRecordSize);
		result = SUCCESS;
	}
	else
	{
		MetaFree(ppDst);
		if ((*ppDst = MetaAlloc(srcRecordSize)) != NULL)
		{
			MEMCPY(*ppDst, pSrc, srcRecordSize);
			result = SUCCESS;		
		}
	}
	return result;
}

extern AECHAR* MetaDB_Type_Name[];

void TMetaDBRecordData_ToString(TMetaDBRecordData* pSrc, AECHAR* buffer, int nSize)
{
	switch (pSrc->fieldDesc.type)
	{
	case META_FIELD_WTEXT:
		WSPRINTF(buffer, nSize, L"type[wtext]id[%d]len[%d]data[%s]", pSrc->fieldDesc.fieldID, pSrc->len, pSrc->pData);
		break;
	case META_FIELD_BINARY:
		WSPRINTF(buffer, nSize, L"type[binary]id[%d]len[%d]data[%hs]", pSrc->fieldDesc.fieldID, pSrc->len, pSrc->pData);
		break;
	case META_FIELD_TEXT:
		WSPRINTF(buffer, nSize, L"type[text]id[%d]len[%d]data[%hs]", pSrc->fieldDesc.fieldID, pSrc->len, pSrc->pData);
		break;
	case META_FIELD_INT32:
		WSPRINTF(buffer, nSize, L"type[int32]id[%d]len[%d]data[%d]", pSrc->fieldDesc.fieldID, pSrc->len, *((int*)pSrc->pData));
		break;
	}
}

void TMetaDBRecordData_DataToString(TMetaDBRecordData* pSrc, AECHAR* buffer, int nSize)
{
	//MEMCPY(buffer, pSrc->pData, pSrc->len);
	int i;
	char* ptr;
	switch (pSrc->fieldDesc.type)
	{
	case META_FIELD_WTEXT:	
		MEMCPY(buffer, pSrc->pData, pSrc->len);
		break;
	case META_FIELD_BINARY:
	case META_FIELD_TEXT:
		ptr= (char*) pSrc->pData;
		for (i = 0; i< pSrc->len;  i++)
		{
			WSPRINTF(buffer + i, nSize - i * sizeof(AECHAR), L"%c", ptr[i]);
		}
		//STRTOWSTR(pSrc->pData, buffer, nSize);		
		break;
	case META_FIELD_INT32:
		WSPRINTF(buffer, nSize, L"%d", *((int*)pSrc->pData));
		break;
	}

}


static int MetaDBRecordData_CreateFieldData(TMetaDBRecordData** ppRecordData, int nFieldId, TMetaFieldTypeEnum dataType, void* pRawData, int nDataSize)
{
	int recordSize;
	//the size must be at least equal to the sizeof struct cause it is 32bit alignment.
	if (nDataSize < sizeof(int32))
	{
		recordSize = META_DBRECORD_SIZE + sizeof(int32);
	}
	else
	{
		recordSize = META_DBRECORD_SIZE + nDataSize;
	}


	if ((*ppRecordData = MetaAlloc(recordSize))!= NULL)
	{
		(*ppRecordData)->fieldDesc.fieldID = nFieldId;
		(*ppRecordData)->fieldDesc.type = dataType;
		(*ppRecordData)->len = nDataSize;
		if (pRawData)
		{
			MEMCPY(&(*ppRecordData)->pData, pRawData, nDataSize);
		}
		return SUCCESS;
	}
	return EFAILED;
}

static int MetaDBRecordData_CreateFieldDataInt32(TMetaDBRecordData** ppRecordData, int nFieldId, int nNumber)
{
	return MetaDBRecordData_CreateFieldData(ppRecordData, nFieldId, META_FIELD_INT32, &nNumber, sizeof(int));
}

static int MetaDBRecordData_CreateFieldDataWText(TMetaDBRecordData** ppRecordData, int nFieldId, AECHAR* pwzStr, int nBytes)
{
	return MetaDBRecordData_CreateFieldData(ppRecordData, nFieldId, META_FIELD_WTEXT, pwzStr, nBytes);
}

static int MetaDBRecordData_CreateFieldDataBinary(TMetaDBRecordData** ppRecordData, int nFieldId, char* pszStr, int nBytes)
{
	return MetaDBRecordData_CreateFieldData(ppRecordData, nFieldId, META_FIELD_BINARY, pszStr, nBytes);
}


static int CMetaDBRecord_GetFieldIndexFromFieldId(CMetaDBRecord* pThis, int nFieldId, ushort* nFieldIndex)
{
	int result = EFAILED;
	ushort i;
	ushort size;
	TMetaDBRecordData* pRecordData;

	if (pThis)
	{
		if (pThis->piColumnList)
		{			
			if (IAList_GetSize(pThis->piColumnList, &size) == SUCCESS)
			{
				for (i = 0; i < size; i ++)
				{
					pRecordData = NULL;
					if (IAList_Get(pThis->piColumnList, i, (void**)&pRecordData) == SUCCESS)
					{
						if (pRecordData)
						{
							if (pRecordData->fieldDesc.fieldID == nFieldId)
							{								
								*nFieldIndex = i;
								result = SUCCESS;
								break;
							}							
						}
					}
				}
			}
		}
	}
	return result;
}


int CMetaDBRecord_GetFieldById(IAList* piList, int id, TMetaDBRecordData**ppRecord)
{
	ushort i, nListCount = 0;
	int result = EFAILED;
	if (id >= 0 && IAList_GetSize(piList, &nListCount) == SUCCESS)
	{
		for (i =0; i< nListCount; i++)
		{
			if (IAList_Get(piList, i, (TAListElement**)ppRecord) == SUCCESS)
			{
				if ((*ppRecord)->fieldDesc.fieldID == id)
				{
					result = SUCCESS;
					break;
				}
			}
			else
			{
				// something unexpected happens
				break;
			}
		}
	}
	return result;
}

/*
static int MetaDBRecordData_Assignment(TMetaDBRecordData* pRecordDest, TMetaDBRecordData* pRecordSrc)
{
	int result = EFAILED;
	
	if (pRecordDest && pRecordSrc)
	{
		MEMCPY(&pRecordDest->fieldDesc,&pRecordSrc->fieldDesc, sizeof(TMetaDBFieldDesc));
		pRecordDest->len = pRecordSrc->len;

		switch (pRecordDest->fieldDesc.type)
		{
		case META_FIELD_BINARY:
		case META_FIELD_TEXT:
		case META_FIELD_WTEXT:
			// in case it has data previously
			if (pRecordDest->data.pData)
			{
				MetaFree(&pRecordDest->data.pData);
			}			
			
			pRecordDest->data.pData = MetaAlloc(pRecordDest->len);
			
			if (pRecordDest->data.pData)
			{
				MEMCPY(pRecordDest->data.pData, pRecordSrc->data.pData, pRecordSrc->len);
				result = SUCCESS;
			}
			break;
		case META_FIELD_INT32:
			pRecordDest->data.i32 = pRecordSrc->data.i32;
			result = SUCCESS;
			break;
		case META_FIELD_INT64:
			pRecordDest->data.i64 = pRecordSrc->data.i64;
			result = SUCCESS;
			break;
		}
	}
	return result;	
}
*/

//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// TODO: Add user code at here                                            
//////////////////////////////////////////////////////////////////////////

static uint32 CMetaDBRecord_IBase_AddRef(IMetaDBRecord* pIMetaDBRecord)
{
    CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;

    pThis->nRefs++;

    return pThis->nRefs;

}

static uint32 CMetaDBRecord_IBase_Release(IMetaDBRecord* pIMetaDBRecord)
{
    CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;

    pThis->nRefs--;
    if(pThis->nRefs == 0)
    {
        CMetaDBRecord_Destructor(pThis);
    }

    return 0;
}

static int CMetaDBRecord_IBase_QueryInterface(IMetaDBRecord* pIMetaDBRecord, AEECLSID ClsID, void** ppInterface)
{
	int result = EUNSUPPORTED;
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	if(ClsID == META_CLSID_DBRECORD) //NEED DEFINITION
	{
		IBASE_COPY_IPTR(*ppInterface, pIMetaDBRecord);
		result = SUCCESS;
	}
    return result;
}

//CMetaDBRecord_IMetaDB_Open



//////////////////////////////////////////////////////////////////////////
// CMetaDBRecord_New() to create component instance                                  
//////////////////////////////////////////////////////////////////////////
int CMetaDBRecord_New(IShell *pIShell, AEECLSID ClsID,void** ppInterface)
{
	int result = SUCCESS;
	CMetaDBRecord* pThis; 
	IMetaDBRecord* pIMetaDBRecord = NULL;
	if(pIShell == NULL || ppInterface == NULL)
	{
		return EBADPARM;
	}

	// MAYBE WE SUPPORT OTHER INTERFACE LATER.
	if(ClsID != META_CLSID_DBRECORD)
	{		
		return EUNSUPPORTED;
	}
	
	pThis = CMetaDBRecord_Constructor(pIShell);
	if(!pThis)
	{
		result =  ENOMEMORY;
		goto Exit;
	}	

	pIMetaDBRecord = &pThis->myIMetaDBRecord;
	// MAYBE WE SUPPORT OTHER INTERFACE LATER.
	
	result = CMetaDBRecord_IBase_QueryInterface(pIMetaDBRecord, ClsID, ppInterface);
	if( result != SUCCESS)
	{
		CMetaDBRecord_Destructor(pThis);
		goto Exit;
	}
	Exit:
	return result;	
}


static CMetaDBRecord* CMetaDBRecord_Constructor(IShell* pIShell)
{
	CMetaDBRecord* pThis = NULL;
	int result = SUCCESS;
	if ((pThis = (CMetaDBRecord*)MetaAlloc(sizeof(CMetaDBRecord))) == NULL)
	{
		return NULL;
	}

	pThis->nRefs = 0;
	ISHELL_AddRef(pIShell);
	pThis->pIShell = pIShell;
	pThis->piColumnList = NULL;

	pThis->myIMetaDBRecord.pvt = &gIMetaDBRecordFuncs;
	pThis->myIMetaDBRecord.pData = (void*)pThis;

    //////////////////////////////////////////////////////////////////////////
    // TODO: Add user construct code here   
	
	// CONSTRUCT ISQLMGR HERE
	pThis->nColumn = 0;
	if (SUCCESS != ISHELL_CreateInstance(pIShell, META_CLSID_ALIST, (void**)&pThis->piColumnList))
	{		
    	CMetaDBRecord_Destructor(pThis);
		pThis->piColumnList = NULL;
		pThis = NULL;
	}	
	return pThis;
    //////////////////////////////////////////////////////////////////////////
}


static void CMetaDBRecord_Destructor(CMetaDBRecord* pThis)
{
    //////////////////////////////////////////////////////////////////////////
    // TODO: Add user destructor code here                                    
	ushort i;
	TMetaDBRecordData* pRecord;
    //////////////////////////////////////////////////////////////////////////   

	if (pThis->piColumnList)
	{		
		for (i = 0; i < pThis->nColumn; i ++)
		{
			// DON'T KNOW WHAT RETURNS...
			if (IAList_Get(pThis->piColumnList, i, (void**)&pRecord) == SUCCESS)
			{
				// TODO : implement this...
				MetaDBRecordData_Release(pRecord); 
				IAList_Remove(pThis->piColumnList, i);
			}
		}
		IBASE_RELEASE_IPTR(pThis->piColumnList);
	}				
	ISHELL_Release(pThis->pIShell);
	MetaFree(&pThis);
}



static int CMetaDBRecord_IMetaDBRecord_GetFieldCount(IMetaDBRecord* pIMetaDBRecord, ushort* pFieldCount)
{
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	int result = EFAILED;

	if (pThis->piColumnList)
	{					
		result = IAList_GetSize(pThis->piColumnList, pFieldCount);					
	}
	return result;
}


// should we check fieldId for validation
static int CMetaDBRecord_IMetaDBRecord_InsertField(IMetaDBRecord* pIMetaDBRecord, TMetaDBRecordData* pRecordData)
{
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	int result = EFAILED;
	ushort nFieldIndex;
	TMetaDBRecordData* pDst;

	if (pRecordData)
	{
		// we need to guaranttee the unique of fieldId
		if (CMetaDBRecord_GetFieldIndexFromFieldId(pThis, pRecordData->fieldDesc.fieldID, &nFieldIndex) != SUCCESS)
		{	
			if (pThis->piColumnList)
			{
				if (TMetaDBRecordData_Clone(pRecordData, &pDst)== SUCCESS)
				{
					result = IAList_Insert(pThis->piColumnList, pDst, &nFieldIndex);
				}
			}		
		}
		else
		{
			//if it is already there, let's copy
			if (IAList_Get(pThis->piColumnList, nFieldIndex, (void**)&pDst) == SUCCESS)
			{
				result = TMetaDBRecordData_Copy(pRecordData, &pDst);
			}
		}
	}
	return result;
}

static int CMetaDBRecord_IMetaDBRecord_RemoveFieldById(IMetaDBRecord* pIMetaDBRecord, int nFieldId)
{
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	int result = EFAILED;
	ushort nFieldIndex;
	TMetaDBRecordData* pRecordData;

	//memory leaking!!
	if (CMetaDBRecord_GetFieldIndexFromFieldId(pThis, nFieldId, &nFieldIndex) == SUCCESS)
	{
		if (IAList_Get(pThis->piColumnList, nFieldIndex, (void**)&pRecordData)== SUCCESS)
		{
			MetaFree(&pRecordData);
			result = IAList_Remove(pThis->piColumnList, nFieldIndex);	
		}
	}
	return result;
}


static int CMetaDBRecord_IMetaDBRecord_RemoveAll(IMetaDBRecord* pIMetaDBRecord)
{
	ushort nListSize = 0;
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	int result = EFAILED;
	TMetaDBRecordData* pRecordData;
	
	if (pThis)
	{
		if (pThis->piColumnList)
		{
			do
			{
				if ((result =IAList_GetSize(pThis->piColumnList, &nListSize))==SUCCESS)
				{
					if (nListSize ==0)
					{
						result = SUCCESS;
						break;
					}
				}
				else
				{
					break;
				}
				
				if ((result =IAList_Get(pThis->piColumnList, nListSize, (void**)&pRecordData))== SUCCESS)
				{
					MetaFree(&pRecordData);				
				}
				else
				{
					break;
				}
				if ((result = IAList_Remove(pThis->piColumnList, nListSize)) != SUCCESS)
				{			
					break;
				}
			}
			while (TRUE);
		}
	}
	return result;
}


static int CMetaDBRecord_IMetaDBRecord_RemoveFieldByIndex(IMetaDBRecord* pIMetaDBRecord, ushort nFieldIndex)
{
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	int result = EFAILED;
	TMetaDBRecordData* pRecordData;

	if (pThis)
	{
		if (pThis->piColumnList)
		{
			if (IAList_Get(pThis->piColumnList, nFieldIndex, (void**)&pRecordData)== SUCCESS)
			{
				MetaFree(&pRecordData);
				result = IAList_Remove(pThis->piColumnList, nFieldIndex);	
			}
		}
	}
	return result;
}


static int CMetaDBRecord_IMetaDBRecord_GetFieldPointerById(IMetaDBRecord* pIMetaDBRecord, int nFieldId, TMetaDBRecordData** ppRecordData)
{
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	int result = EFAILED;

	if (pThis)
	{
		if (pThis->piColumnList)
		{				
			result = CMetaDBRecord_GetFieldById(pThis->piColumnList, nFieldId, ppRecordData);
		}	
	}

	return result;
}


static int CMetaDBRecord_IMetaDBRecord_GetFieldPointerByIndex(IMetaDBRecord* pIMetaDBRecord, ushort index, TMetaDBRecordData** ppRecordData)
{
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	int result = EFAILED;
	if (pThis)
	{
		if (pThis->piColumnList)
		{								
			result = IAList_Get(pThis->piColumnList, index, (void**)ppRecordData);				
		}
	}
	return result;
}

static int CMetaDBRecord_IMetaDBRecord_InsertFieldData(IMetaDBRecord* pIMetaDBRecord, int nFieldId, TMetaFieldTypeEnum dataType, void* pRawData, int nDataSize)
{
	CMetaDBRecord* pThis = (CMetaDBRecord* )pIMetaDBRecord->pData;
	int result = EFAILED;
	ushort nListSize, nPos = 0;
	TMetaDBRecordData* pRecordData;

	int srcRecordSize, dstRecordSize;

	if (pThis)
	{
		if (pThis->piColumnList)
		{				
			//we need to guarantee the unique fieldID
			if (CMetaDBRecord_GetFieldIndexFromFieldId(pThis, nFieldId, &nPos) != SUCCESS)
			{
				if (SUCCESS == MetaDBRecordData_CreateFieldData(&pRecordData, nFieldId, dataType, pRawData, nDataSize))
				{					
					if (IAList_GetSize(pThis->piColumnList, &nListSize) == SUCCESS)
					{
						result = IAList_Insert(pThis->piColumnList, pRecordData, &nListSize);
					}
				}
			}
			else
			{
				if (IAList_Get(pThis->piColumnList, nPos, (void**)&pRecordData) == SUCCESS)
				{
					srcRecordSize = META_DBRECORD_SIZE + MAX(nDataSize, sizeof(int32));
					dstRecordSize = CALC_META_DBRECORD_SIZE(pRecordData);

					if (dstRecordSize < srcRecordSize)
					{
						if (IAList_Remove(pThis->piColumnList, nPos) == SUCCESS)
						{
							MetaFree(&pRecordData);
							if ((pRecordData = MetaAlloc(srcRecordSize)) != NULL)
							{
								result = IAList_Insert(pThis->piColumnList, pRecordData, &nPos);
							}
						}
					}
					else
					{
						//THE SIZE IS OK, SO, NO REASON TO FAIL
						result = SUCCESS;
					}
					if (result == SUCCESS)
					{
						pRecordData->fieldDesc.type = dataType;
						pRecordData->fieldDesc.fieldID = nFieldId;
						pRecordData->len = nDataSize;
						if (pRawData)
						{
							MEMCPY(pRecordData->pData, pRawData, nDataSize);
						}
					}
				}
			}
		}	
	}						
	return result;
}





/*=====================================================================

  INTERFACE  DOCUMENTATION

=======================================================================


Interface Name: IMetaDBRecord


==============================================================================
	Method:  IMetaDBRecord_GetFieldCount()

Description:This method gets the number of field in record

Prototype:  unit32 IMetaDBRecord_GetFieldCount(IMetaDBRecord* pIMetaDBRecord, ushort* pFieldCount);
            pIMetaDBRecord         in
            pFieldCount            out
            
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EFAILED
	 EBADPARM  - parameter is error
==============================================================================

  	Method:  IMetaDBRecord_InsertField()

Description:This method insert one field data record. Becareful: the TMetaDBRecordData is in continuous memory address. User
			is recommanded to use "IMetaDBRecord_InsertFieldData" to insert field data. 
			This method is typically useful when "createTable" when only field id and field type is useful. To insert data record,
			try to use "IMetaDBRecord_InsertFieldData".


Prototype:  unit32 IMetaDBRecord_InsertField(IMetaDBRecord* pIMetaDBRecord, TMetaDBRecordData* pRecordData);
            pIMetaDBRecord         in
            pRecordData            in (user defined field information, when used in create table, only type and field id is used)

            
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EFAILED
	 EBADPARM  - parameter is error
==============================================================================
  
  	Method:  IMetaDBRecord_RemoveFieldById()

Description:This method remove one field in record by searching field id.

Prototype:  unit32 IMetaDBRecord_RemoveFieldById(IMetaDBRecord* pIMetaDBRecord, int nFieldId);
            pIMetaDBRecord         in
            nFieldId               in (The field id)
            
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EFAILED
	 EBADPARM  - parameter is error
==============================================================================

  	Method:  IMetaDBRecord_RemoveFieldByIndex()

Description:This method removes one field by its internal index.

Prototype:  unit32 IMetaDBRecord_RemoveFieldByIndex(IMetaDBRecord* pIMetaDBRecord, ushort nIndex);
            pIMetaDBRecord         in
            nIndex                 in (this index has nothing to do with field id and it depends on sequence of inserting, 
									The only usage of this interface is for enumeration of all fields in record.)
            
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EFAILED
	 EBADPARM  - parameter is error
==============================================================================

  Method:  IMetaDBRecord_GetFieldPointerById()

Description:This method gets one field data by searching its field id

Prototype:  unit32 IMetaDBRecord_GetFieldPointerById(IMetaDBRecord* pIMetaDBRecord, int nFieldId, TMetaDBRecordData** ppRecordData);
            pIMetaDBRecord         in
            nFieldId               in (If the field id cannot be found, method fails.)
			ppRecordData           out(User is responsible to release pointer when finished.)

            
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EFAILED
	 EBADPARM  - parameter is error
==============================================================================
  
  Method:  IMetaDBRecord_GetFieldPointerByIndex()

Description:This method gets one field data by emumerating its internal index.

Prototype:  unit32 IMetaDBRecord_GetFieldPointerByIndex(IMetaDBRecord* pIMetaDBRecord, ushort nFieldIndex, TMetaDBRecordData** ppRecordData);
            pIMetaDBRecord         in
            nFieldIndex            in (The field index depends on sequence when inserted and it is only useful when enumerating fields.)
			ppRecordData           out(User is responsible to release pointer when finished.)

            
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EFAILED
	 EBADPARM  - parameter is error
==============================================================================

    
  Method:  IMetaDBRecord_InsertFieldData()

Description:This method insert one field data into record. This is recommanded method when inserting data field because
	the memory calculation of size of internal TMetaDBRecordData is not supposed to be known to user.

Prototype:  unit32 IMetaDBRecord_InsertFieldData(IMetaDBRecord* pIMetaDBRecord, int nFieldId, TMetaFieldTypeEnum dataType, void* pRawData, int nDataSize);
            pIMetaDBRecord      in
            nFieldId            in (The field id can start from 0.)
			dataType            in(currently only a few data type is supported. NULL-type in DB is not supported yet.)
			pRawData            in
			nDataSize			in (data size in bytes)
            
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EFAILED
	 EBADPARM  - parameter is error
==============================================================================
     
  Method:  IMetaDBRecord_RemoveAll()

Description:This method removes all fields in record.

Prototype:  unit32 IMetaDBRecord_RemoveAll(IMetaDBRecord* pIMetaDBRecord);
            pIMetaDBRecord      in
                  
Return Value:
   If succesful, return SUCCESS
   If failed,
	 EFAILED
	 EBADPARM  - parameter is error
==============================================================================

  */